// Code generated by ent, DO NOT EDIT.

package post

import (
	"gochassis/ent/predicate"
	"gochassis/ent/schema"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldID, id))
}

// Image applies equality check predicate on the "image" field. It's identical to ImageEQ.
func Image(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldImage, v))
}

// Content applies equality check predicate on the "content" field. It's identical to ContentEQ.
func Content(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldContent, v))
}

// ProfileDisplayname applies equality check predicate on the "profile_displayname" field. It's identical to ProfileDisplaynameEQ.
func ProfileDisplayname(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldProfileDisplayname, v))
}

// ProfileBirthYear applies equality check predicate on the "profile_birth_year" field. It's identical to ProfileBirthYearEQ.
func ProfileBirthYear(v int16) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldProfileBirthYear, v))
}

// ProfileGender applies equality check predicate on the "profile_gender" field. It's identical to ProfileGenderEQ.
func ProfileGender(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldProfileGender, v))
}

// Coordinates applies equality check predicate on the "coordinates" field. It's identical to CoordinatesEQ.
func Coordinates(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldCoordinates, v))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldUpdatedAt, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldDeletedAt, v))
}

// ReplyTo applies equality check predicate on the "reply_to" field. It's identical to ReplyToEQ.
func ReplyTo(v int) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldReplyTo, v))
}

// ImageEQ applies the EQ predicate on the "image" field.
func ImageEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldImage, v))
}

// ImageNEQ applies the NEQ predicate on the "image" field.
func ImageNEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldImage, v))
}

// ImageIn applies the In predicate on the "image" field.
func ImageIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldImage, vs...))
}

// ImageNotIn applies the NotIn predicate on the "image" field.
func ImageNotIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldImage, vs...))
}

// ImageGT applies the GT predicate on the "image" field.
func ImageGT(v string) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldImage, v))
}

// ImageGTE applies the GTE predicate on the "image" field.
func ImageGTE(v string) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldImage, v))
}

// ImageLT applies the LT predicate on the "image" field.
func ImageLT(v string) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldImage, v))
}

// ImageLTE applies the LTE predicate on the "image" field.
func ImageLTE(v string) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldImage, v))
}

// ImageContains applies the Contains predicate on the "image" field.
func ImageContains(v string) predicate.Post {
	return predicate.Post(sql.FieldContains(FieldImage, v))
}

// ImageHasPrefix applies the HasPrefix predicate on the "image" field.
func ImageHasPrefix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasPrefix(FieldImage, v))
}

// ImageHasSuffix applies the HasSuffix predicate on the "image" field.
func ImageHasSuffix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasSuffix(FieldImage, v))
}

// ImageEqualFold applies the EqualFold predicate on the "image" field.
func ImageEqualFold(v string) predicate.Post {
	return predicate.Post(sql.FieldEqualFold(FieldImage, v))
}

// ImageContainsFold applies the ContainsFold predicate on the "image" field.
func ImageContainsFold(v string) predicate.Post {
	return predicate.Post(sql.FieldContainsFold(FieldImage, v))
}

// ContentEQ applies the EQ predicate on the "content" field.
func ContentEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldContent, v))
}

// ContentNEQ applies the NEQ predicate on the "content" field.
func ContentNEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldContent, v))
}

// ContentIn applies the In predicate on the "content" field.
func ContentIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldContent, vs...))
}

// ContentNotIn applies the NotIn predicate on the "content" field.
func ContentNotIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldContent, vs...))
}

// ContentGT applies the GT predicate on the "content" field.
func ContentGT(v string) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldContent, v))
}

// ContentGTE applies the GTE predicate on the "content" field.
func ContentGTE(v string) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldContent, v))
}

// ContentLT applies the LT predicate on the "content" field.
func ContentLT(v string) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldContent, v))
}

// ContentLTE applies the LTE predicate on the "content" field.
func ContentLTE(v string) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldContent, v))
}

// ContentContains applies the Contains predicate on the "content" field.
func ContentContains(v string) predicate.Post {
	return predicate.Post(sql.FieldContains(FieldContent, v))
}

// ContentHasPrefix applies the HasPrefix predicate on the "content" field.
func ContentHasPrefix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasPrefix(FieldContent, v))
}

// ContentHasSuffix applies the HasSuffix predicate on the "content" field.
func ContentHasSuffix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasSuffix(FieldContent, v))
}

// ContentEqualFold applies the EqualFold predicate on the "content" field.
func ContentEqualFold(v string) predicate.Post {
	return predicate.Post(sql.FieldEqualFold(FieldContent, v))
}

// ContentContainsFold applies the ContainsFold predicate on the "content" field.
func ContentContainsFold(v string) predicate.Post {
	return predicate.Post(sql.FieldContainsFold(FieldContent, v))
}

// ProfileDisplaynameEQ applies the EQ predicate on the "profile_displayname" field.
func ProfileDisplaynameEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldProfileDisplayname, v))
}

// ProfileDisplaynameNEQ applies the NEQ predicate on the "profile_displayname" field.
func ProfileDisplaynameNEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldProfileDisplayname, v))
}

// ProfileDisplaynameIn applies the In predicate on the "profile_displayname" field.
func ProfileDisplaynameIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldProfileDisplayname, vs...))
}

// ProfileDisplaynameNotIn applies the NotIn predicate on the "profile_displayname" field.
func ProfileDisplaynameNotIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldProfileDisplayname, vs...))
}

// ProfileDisplaynameGT applies the GT predicate on the "profile_displayname" field.
func ProfileDisplaynameGT(v string) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldProfileDisplayname, v))
}

// ProfileDisplaynameGTE applies the GTE predicate on the "profile_displayname" field.
func ProfileDisplaynameGTE(v string) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldProfileDisplayname, v))
}

// ProfileDisplaynameLT applies the LT predicate on the "profile_displayname" field.
func ProfileDisplaynameLT(v string) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldProfileDisplayname, v))
}

// ProfileDisplaynameLTE applies the LTE predicate on the "profile_displayname" field.
func ProfileDisplaynameLTE(v string) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldProfileDisplayname, v))
}

// ProfileDisplaynameContains applies the Contains predicate on the "profile_displayname" field.
func ProfileDisplaynameContains(v string) predicate.Post {
	return predicate.Post(sql.FieldContains(FieldProfileDisplayname, v))
}

// ProfileDisplaynameHasPrefix applies the HasPrefix predicate on the "profile_displayname" field.
func ProfileDisplaynameHasPrefix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasPrefix(FieldProfileDisplayname, v))
}

// ProfileDisplaynameHasSuffix applies the HasSuffix predicate on the "profile_displayname" field.
func ProfileDisplaynameHasSuffix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasSuffix(FieldProfileDisplayname, v))
}

// ProfileDisplaynameEqualFold applies the EqualFold predicate on the "profile_displayname" field.
func ProfileDisplaynameEqualFold(v string) predicate.Post {
	return predicate.Post(sql.FieldEqualFold(FieldProfileDisplayname, v))
}

// ProfileDisplaynameContainsFold applies the ContainsFold predicate on the "profile_displayname" field.
func ProfileDisplaynameContainsFold(v string) predicate.Post {
	return predicate.Post(sql.FieldContainsFold(FieldProfileDisplayname, v))
}

// ProfileBirthYearEQ applies the EQ predicate on the "profile_birth_year" field.
func ProfileBirthYearEQ(v int16) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldProfileBirthYear, v))
}

// ProfileBirthYearNEQ applies the NEQ predicate on the "profile_birth_year" field.
func ProfileBirthYearNEQ(v int16) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldProfileBirthYear, v))
}

// ProfileBirthYearIn applies the In predicate on the "profile_birth_year" field.
func ProfileBirthYearIn(vs ...int16) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldProfileBirthYear, vs...))
}

// ProfileBirthYearNotIn applies the NotIn predicate on the "profile_birth_year" field.
func ProfileBirthYearNotIn(vs ...int16) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldProfileBirthYear, vs...))
}

// ProfileBirthYearGT applies the GT predicate on the "profile_birth_year" field.
func ProfileBirthYearGT(v int16) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldProfileBirthYear, v))
}

// ProfileBirthYearGTE applies the GTE predicate on the "profile_birth_year" field.
func ProfileBirthYearGTE(v int16) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldProfileBirthYear, v))
}

// ProfileBirthYearLT applies the LT predicate on the "profile_birth_year" field.
func ProfileBirthYearLT(v int16) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldProfileBirthYear, v))
}

// ProfileBirthYearLTE applies the LTE predicate on the "profile_birth_year" field.
func ProfileBirthYearLTE(v int16) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldProfileBirthYear, v))
}

// ProfileBirthYearIsNil applies the IsNil predicate on the "profile_birth_year" field.
func ProfileBirthYearIsNil() predicate.Post {
	return predicate.Post(sql.FieldIsNull(FieldProfileBirthYear))
}

// ProfileBirthYearNotNil applies the NotNil predicate on the "profile_birth_year" field.
func ProfileBirthYearNotNil() predicate.Post {
	return predicate.Post(sql.FieldNotNull(FieldProfileBirthYear))
}

// ProfileGenderEQ applies the EQ predicate on the "profile_gender" field.
func ProfileGenderEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldProfileGender, v))
}

// ProfileGenderNEQ applies the NEQ predicate on the "profile_gender" field.
func ProfileGenderNEQ(v string) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldProfileGender, v))
}

// ProfileGenderIn applies the In predicate on the "profile_gender" field.
func ProfileGenderIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldProfileGender, vs...))
}

// ProfileGenderNotIn applies the NotIn predicate on the "profile_gender" field.
func ProfileGenderNotIn(vs ...string) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldProfileGender, vs...))
}

// ProfileGenderGT applies the GT predicate on the "profile_gender" field.
func ProfileGenderGT(v string) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldProfileGender, v))
}

// ProfileGenderGTE applies the GTE predicate on the "profile_gender" field.
func ProfileGenderGTE(v string) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldProfileGender, v))
}

// ProfileGenderLT applies the LT predicate on the "profile_gender" field.
func ProfileGenderLT(v string) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldProfileGender, v))
}

// ProfileGenderLTE applies the LTE predicate on the "profile_gender" field.
func ProfileGenderLTE(v string) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldProfileGender, v))
}

// ProfileGenderContains applies the Contains predicate on the "profile_gender" field.
func ProfileGenderContains(v string) predicate.Post {
	return predicate.Post(sql.FieldContains(FieldProfileGender, v))
}

// ProfileGenderHasPrefix applies the HasPrefix predicate on the "profile_gender" field.
func ProfileGenderHasPrefix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasPrefix(FieldProfileGender, v))
}

// ProfileGenderHasSuffix applies the HasSuffix predicate on the "profile_gender" field.
func ProfileGenderHasSuffix(v string) predicate.Post {
	return predicate.Post(sql.FieldHasSuffix(FieldProfileGender, v))
}

// ProfileGenderIsNil applies the IsNil predicate on the "profile_gender" field.
func ProfileGenderIsNil() predicate.Post {
	return predicate.Post(sql.FieldIsNull(FieldProfileGender))
}

// ProfileGenderNotNil applies the NotNil predicate on the "profile_gender" field.
func ProfileGenderNotNil() predicate.Post {
	return predicate.Post(sql.FieldNotNull(FieldProfileGender))
}

// ProfileGenderEqualFold applies the EqualFold predicate on the "profile_gender" field.
func ProfileGenderEqualFold(v string) predicate.Post {
	return predicate.Post(sql.FieldEqualFold(FieldProfileGender, v))
}

// ProfileGenderContainsFold applies the ContainsFold predicate on the "profile_gender" field.
func ProfileGenderContainsFold(v string) predicate.Post {
	return predicate.Post(sql.FieldContainsFold(FieldProfileGender, v))
}

// CoordinatesEQ applies the EQ predicate on the "coordinates" field.
func CoordinatesEQ(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldCoordinates, v))
}

// CoordinatesNEQ applies the NEQ predicate on the "coordinates" field.
func CoordinatesNEQ(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldCoordinates, v))
}

// CoordinatesIn applies the In predicate on the "coordinates" field.
func CoordinatesIn(vs ...*schema.Point) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldCoordinates, vs...))
}

// CoordinatesNotIn applies the NotIn predicate on the "coordinates" field.
func CoordinatesNotIn(vs ...*schema.Point) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldCoordinates, vs...))
}

// CoordinatesGT applies the GT predicate on the "coordinates" field.
func CoordinatesGT(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldCoordinates, v))
}

// CoordinatesGTE applies the GTE predicate on the "coordinates" field.
func CoordinatesGTE(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldCoordinates, v))
}

// CoordinatesLT applies the LT predicate on the "coordinates" field.
func CoordinatesLT(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldCoordinates, v))
}

// CoordinatesLTE applies the LTE predicate on the "coordinates" field.
func CoordinatesLTE(v *schema.Point) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldCoordinates, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldUpdatedAt, v))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.Post {
	return predicate.Post(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.Post {
	return predicate.Post(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.Post {
	return predicate.Post(sql.FieldNotNull(FieldDeletedAt))
}

// ReplyToEQ applies the EQ predicate on the "reply_to" field.
func ReplyToEQ(v int) predicate.Post {
	return predicate.Post(sql.FieldEQ(FieldReplyTo, v))
}

// ReplyToNEQ applies the NEQ predicate on the "reply_to" field.
func ReplyToNEQ(v int) predicate.Post {
	return predicate.Post(sql.FieldNEQ(FieldReplyTo, v))
}

// ReplyToIn applies the In predicate on the "reply_to" field.
func ReplyToIn(vs ...int) predicate.Post {
	return predicate.Post(sql.FieldIn(FieldReplyTo, vs...))
}

// ReplyToNotIn applies the NotIn predicate on the "reply_to" field.
func ReplyToNotIn(vs ...int) predicate.Post {
	return predicate.Post(sql.FieldNotIn(FieldReplyTo, vs...))
}

// ReplyToIsNil applies the IsNil predicate on the "reply_to" field.
func ReplyToIsNil() predicate.Post {
	return predicate.Post(sql.FieldIsNull(FieldReplyTo))
}

// ReplyToNotNil applies the NotNil predicate on the "reply_to" field.
func ReplyToNotNil() predicate.Post {
	return predicate.Post(sql.FieldNotNull(FieldReplyTo))
}

// HasChatRooms applies the HasEdge predicate on the "chat_rooms" edge.
func HasChatRooms() predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, ChatRoomsTable, ChatRoomsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasChatRoomsWith applies the HasEdge predicate on the "chat_rooms" edge with a given conditions (other predicates).
func HasChatRoomsWith(preds ...predicate.ChatRoom) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := newChatRoomsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasPostedBy applies the HasEdge predicate on the "posted_by" edge.
func HasPostedBy() predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, PostedByTable, PostedByColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasPostedByWith applies the HasEdge predicate on the "posted_by" edge with a given conditions (other predicates).
func HasPostedByWith(preds ...predicate.Profile) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := newPostedByStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasLikedBy applies the HasEdge predicate on the "liked_by" edge.
func HasLikedBy() predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, true, LikedByTable, LikedByPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasLikedByWith applies the HasEdge predicate on the "liked_by" edge with a given conditions (other predicates).
func HasLikedByWith(preds ...predicate.Profile) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := newLikedByStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasReplyToEdge applies the HasEdge predicate on the "reply_to_edge" edge.
func HasReplyToEdge() predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, ReplyToEdgeTable, ReplyToEdgeColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasReplyToEdgeWith applies the HasEdge predicate on the "reply_to_edge" edge with a given conditions (other predicates).
func HasReplyToEdgeWith(preds ...predicate.Post) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := newReplyToEdgeStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasReplies applies the HasEdge predicate on the "replies" edge.
func HasReplies() predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, RepliesTable, RepliesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasRepliesWith applies the HasEdge predicate on the "replies" edge with a given conditions (other predicates).
func HasRepliesWith(preds ...predicate.Post) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		step := newRepliesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Post) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Post) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Post) predicate.Post {
	return predicate.Post(func(s *sql.Selector) {
		p(s.Not())
	})
}
